Index: soft/giet_vm/boot/boot_init.c
===================================================================
--- soft/giet_vm/boot/boot_init.c	(revision 236)
+++ soft/giet_vm/boot/boot_init.c	(revision 238)
@@ -7,7 +7,11 @@
 // The boot_init.c file is part of the GIET-VM nano-kernel.
 // This code is executed in the boot phase by proc[0] to initialize the
-//  peripherals and the kernel data structures:
+// peripherals and the kernel data structures:
 // - pages tables for the various vspaces
 // - shedulers for processors (including the tasks contexts and interrupt vectors)
+//
+// This nano-kernel has been written for the MIPS32 processor.
+// The virtual adresses are on 32 bits and use the (unsigned int) type, but the 
+// physicals addresses can have up to 40 bits, and use the  (unsigned long long) type.
 //
 // The GIET-VM uses the paged virtual memory and the MAPPING_INFO binary file
@@ -20,11 +24,12 @@
 // The MAPPING_INFO binary data structure must be loaded in the the seg_boot_mapping 
 // segment (at address seg_mapping_base).
-// This MAPPING_INFO data structure defines both the hardware architecture
-// and the mapping:
-// - physical segmentation of the physical address space, 
-// - virtual spaces definition (one multi-task application per vspace), 
-// - placement of virtual objects (vobj) in the virtual segments (vseg).
-// - placement of virtual segments (vseg) in the physical segments (pseg).
-// - placement of tasks on the processors, 
+// This MAPPING_INFO data structure defines 
+// - the hardware architecture: number of clusters, number or processors, 
+//   size of the memory segments, and peripherals in each cluster.
+// - The structure of the various multi-threaded software applications:
+//   number of tasks, communication channels.
+// - The mapping: placement of virtual objects (vobj) in the virtual segments (vseg),
+//   placement of virtual segments (vseg) in the physical segments (pseg), placement 
+//   of software tasks on the processors, 
 //
 // The page table are statically build in the boot phase, and they do not 
@@ -35,8 +40,8 @@
 // The max number of virtual spaces (GIET_NB_VSPACE_MAX) is a configuration parameter.
 //
-// Each page table (one page table per virtual space) is monolithic, and
-// contains one PT1 and (GIET_NB_PT2_MAX) PT2s. The PT1 is addressed using the ix1 field
+// Each page table (one page table per virtual space) is monolithic, and contains 
+// one PT1 and up to (GIET_NB_PT2_MAX) PT2s. The PT1 is addressed using the ix1 field
 // (11 bits) of the VPN, and the selected PT2 is addressed using the ix2 field (9 bits).
-// - PT1[2048] : a first 8K aligned array of unsigned int, indexed by the (ix1) field of VPN. 
+// - PT1[2048] : a first 8K aligned array of unsigned int, indexed by (ix1) field of VPN. 
 //   Each entry in the PT1 contains a 32 bits PTD. The MSB bit PTD[31] is 
 //   the PTD valid bit, and LSB bits PTD[19:0] are the 20 MSB bits of the physical base
@@ -44,5 +49,5 @@
 //   The PT1 contains 2048 PTD of 4 bytes => 8K bytes.
 // - PT2[1024][GIET_NB_PT2_MAX] : an array of array of unsigned int. 
-//   Each PT2[1024] must be 4K aligned,  and each entry in a PT2 contains two unsigned int: 
+//   Each PT2[1024] must be 4K aligned, each entry in a PT2 contains two unsigned int: 
 //   the first word contains the protection flags, and the second word contains the PPN.
 //   Each PT2 contains 512 PTE2 of 8bytes => 4K bytes.
@@ -64,5 +69,4 @@
 #include <stdarg.h>
 
-
 #if !defined(NB_CLUSTERS)
 # error The NB_CLUSTERS value must be defined in the 'giet_config.h' file !
@@ -79,14 +83,15 @@
 ////////////////////////////////////////////////////////////////////////////
 //      Global variables for boot code
-// As both the page tables and the schedulers are physically distributed,
-// these global variables are just arrays of pointers. 
+// Both the page tables for the various virtual spaces, and the schedulers
+// for the processors are physically distributed on the clusters.
+// These global variables are just arrays of pointers. 
 ////////////////////////////////////////////////////////////////////////////
 
-// Page table pointers array
-page_table_t * boot_ptabs_vaddr[GIET_NB_VSPACE_MAX];
-page_table_t * boot_ptabs_paddr[GIET_NB_VSPACE_MAX];
-
-// Scheduler pointers array
-static_scheduler_t * boot_schedulers_paddr[NB_CLUSTERS * NB_PROCS_MAX];
+// Page table addresses arrays
+paddr_t      boot_ptabs_paddr[GIET_NB_VSPACE_MAX];
+unsigned int boot_ptabs_vaddr[GIET_NB_VSPACE_MAX];
+
+// Scheduler pointers array (virtual addresses)
+static_scheduler_t* boot_schedulers[NB_CLUSTERS * NB_PROCS_MAX];
 
 // Next free PT2 index array
@@ -102,5 +107,6 @@
 // boot_procid() 
 //////////////////////////////////////////////////////////////////////////////
-inline unsigned int boot_procid() {
+inline unsigned int boot_procid() 
+{
     unsigned int ret;
     asm volatile ("mfc0 %0, $15, 1":"=r" (ret));
@@ -108,9 +114,9 @@
 }
 
-
 //////////////////////////////////////////////////////////////////////////////
 // boot_proctime() 
 //////////////////////////////////////////////////////////////////////////////
-inline unsigned int boot_proctime() {
+inline unsigned int boot_proctime() 
+{
     unsigned int ret;
     asm volatile ("mfc0 %0, $9":"=r" (ret));
@@ -118,14 +124,11 @@
 }
 
-
 //////////////////////////////////////////////////////////////////////////////
 // boot_exit() 
 //////////////////////////////////////////////////////////////////////////////
-void boot_exit() {
-    while (1) {
-        asm volatile ("nop");
-    }
-}
-
+void boot_exit() 
+{
+    while (1) { asm volatile ("nop"); }
+}
 
 //////////////////////////////////////////////////////////////////////////////
@@ -134,172 +137,61 @@
 // in all task contexts (when the task has never been executed.
 /////////////////////////////////"/////////////////////////////////////////////
-void boot_eret() {
+void boot_eret() 
+{
     asm volatile ("eret");
 }
 
-
-//////////////////////////////////////////////////////////////////////////////
-// boot_scheduler_set_context()
-// This function set a context slot in a scheduler, after a temporary
-// desactivation of the DTLB (because we use the scheduler physical address).
-// - gpid   : global processor/scheduler index
-// - ltid   : local task index
-// - slotid : context slot index
-// - value  : value to be written 
-//////////////////////////////////////////////////////////////////////////////
-inline void boot_scheduler_set_context(unsigned int gpid,
-        unsigned int ltid,
-        unsigned int slotid,
-        unsigned int value) {
-    // get scheduler physical address
-    static_scheduler_t * psched = boot_schedulers_paddr[gpid];
-
-    // get slot physical address
-    unsigned int * pslot = &(psched->context[ltid][slotid]);
-
-    asm volatile ("li      $26,    0xB     \n"
-            "mtc2    $26,    $1      \n"    /* desactivate DTLB */
-            "sw      %1,     0(%0)   \n"    /* *pslot <= value  */
-            "li      $26,    0xF     \n"
-            "mtc2    $26,    $1      \n"    /* activate DTLB    */
+////////////////////////////////////////////////////////////////////////////
+// boot_physical_read()
+// This function makes a physical read access to a 32 bits word in memory, 
+// after a temporary DTLB de-activation and paddr extension.
+////////////////////////////////////////////////////////////////////////////
+unsigned int boot_physical_read(paddr_t paddr) 
+{
+    unsigned int value;
+    unsigned int lsb = (unsigned int)paddr;
+    unsigned int msb = (unsigned int)(paddr >> 32);
+
+    asm volatile(
+            "mfc2   $2,     $1                 \n"     /* $2 <= MMU_MODE   */
+            "andi   $3,     $2,        0xb     \n"
+            "mtc2   $3,     $1                 \n"     /* DTLB off         */    
+
+            "mtc2   %2,     $24                \n"     /* PADDR_EXT <= msb */   
+            "lw     %0,     0(%1)              \n"     /* value <= *paddr  */
+            "mtc2   $0,     $24                \n"     /* PADDR_EXT <= 0   */   
+
+            "mtc2   $2,     $1                 \n"     /* restore MMU_MODE */
+            : "=r" (value)
+            : "r" (lsb), "r" (msb)
+            : "$2", "$3");
+    return value;
+}
+
+////////////////////////////////////////////////////////////////////////////
+// boot_physical_write()
+// This function makes a physical write access to a 32 bits word in memory, 
+// after a temporary DTLB de-activation and paddr extension.
+////////////////////////////////////////////////////////////////////////////
+void boot_physical_write(paddr_t      paddr, 
+                         unsigned int value) 
+{
+    unsigned int lsb = (unsigned int)paddr;
+    unsigned int msb = (unsigned int)(paddr >> 32);
+
+    asm volatile(
+            "mfc2   $2,     $1                 \n"     /* $2 <= MMU_MODE   */
+            "andi   $3,     $2,        0xb     \n"
+            "mtc2   $3,     $1                 \n"     /* DTLB off         */    
+
+            "mtc2   %2,     $24                \n"     /* PADDR_EXT <= msb */   
+            "sw     %0,     0(%1)              \n"     /* *paddr <= value  */
+            "mtc2   $0,     $24                \n"     /* PADDR_EXT <= 0   */   
+
+            "mtc2   $2,     $1                 \n"     /* restore MMU_MODE */
             :
-            :"r" (pslot), "r"(value)
-            :"$26");
-}
-
-
-//////////////////////////////////////////////////////////////////////////////
-// boot_scheduler_set_itvector()
-// This function set an interrupt vector slot in a scheduler, after a temporary
-// desactivation of the DTLB (because we use the scheduler physical address).
-// - gpid   : global processor/scheduler index
-// - slotid : context slot index
-// - value  : value to be written 
-//////////////////////////////////////////////////////////////////////////////
-inline void boot_scheduler_set_itvector(unsigned int gpid,
-        unsigned int slotid,
-        unsigned int value) {
-    // get scheduler physical address
-    static_scheduler_t * psched = boot_schedulers_paddr[gpid];
-
-    // get slot physical address
-    unsigned int * pslot = &(psched->interrupt_vector[slotid]);
-
-    asm volatile ("li      $26,    0xB     \n"
-            "mtc2    $26,    $1      \n"    /* desactivate DTLB */
-            "sw      %1,     0(%0)   \n"    /* *pslot <= value  */
-            "li      $26,    0xF     \n"
-            "mtc2    $26,    $1      \n"    /* activate DTLB    */
-            :
-            :"r" (pslot), "r"(value)
-            :"$26");
-}
-
-
-//////////////////////////////////////////////////////////////////////////////
-// boot_scheduler_get_itvector()
-// This function get an interrupt vector slot in a scheduler, after a temporary
-// desactivation of the DTLB (because we use the scheduler physical address).
-// - gpid   : global processor/scheduler index
-// - slotid : context slot index
-// - return the content of the slot 
-//////////////////////////////////////////////////////////////////////////////
-unsigned int boot_scheduler_get_itvector(unsigned int gpid, unsigned int slotid) {
-    unsigned int value;
-
-    // get scheduler physical address
-    static_scheduler_t * psched = boot_schedulers_paddr[gpid];
-
-    // get slot physical address
-    unsigned int * pslot = &(psched->interrupt_vector[slotid]);
-
-    asm volatile ("li      $26,    0xB     \n"
-            "mtc2    $26,    $1      \n"    /* desactivate DTLB */
-            "lw      %0,     0(%1)   \n"    /* *pslot <= value  */
-            "li      $26,    0xF     \n"
-            "mtc2    $26,    $1      \n"    /* activate DTLB    */
-            :"=r" (value)
-            :"r"(pslot)
-            :"$26");
-    return value;
-}
-
-
-//////////////////////////////////////////////////////////////////////////////
-// boot_scheduler_get_tasks()
-// This function returns the "tasks" field of a scheduler, after temporary 
-// desactivation of the DTLB (because we use the scheduler physical address).
-// - gpid   : global processor/scheduler index
-//////////////////////////////////////////////////////////////////////////////
-inline unsigned int boot_scheduler_get_tasks(unsigned int gpid) {
-    unsigned int ret;
-
-    // get scheduler physical address
-    static_scheduler_t * psched = boot_schedulers_paddr[gpid];
-
-    // get tasks physical address
-    unsigned int * ptasks = &(psched->tasks);
-
-    asm volatile ("li      $26,    0xB     \n"
-            "mtc2    $26,    $1      \n"    /* desactivate DTLB */
-            "lw      %0,     0(%1)   \n"    /* ret <= *ptasks   */
-            "li      $26,    0xF     \n"
-            "mtc2    $26,    $1      \n"    /* activate DTLB    */
-            :"=r" (ret)
-            :"r"(ptasks)
-            :"$26");
-    return ret;
-}
-
-
-//////////////////////////////////////////////////////////////////////////////
-// boot_scheduler_set_tasks()
-// This function set the "tasks" field of a scheduler, after temporary 
-// desactivation of the DTLB (because we use the scheduler physical address).
-// - gpid   : global processor/scheduler index
-// - value  : value to be written 
-//////////////////////////////////////////////////////////////////////////////
-inline void boot_scheduler_set_tasks(unsigned int gpid, unsigned int value) {
-    // get scheduler physical address
-    static_scheduler_t * psched = boot_schedulers_paddr[gpid];
-
-    // get tasks physical address
-    unsigned int * ptasks = &(psched->tasks);
-
-    asm volatile ("li      $26,    0xB     \n"
-            "mtc2    $26,    $1      \n"    /* desactivate DTLB */
-            "sw      %1,     0(%0)   \n"    /* *ptasks <= value */
-            "li      $26,    0xF     \n"
-            "mtc2    $26,    $1      \n"    /* activate DTLB    */
-            :
-            :"r" (ptasks), "r"(value)
-            :"$26");
-}
-
-
-//////////////////////////////////////////////////////////////////////////////
-// boot_scheduler_set_current()
-// This function set the "current" field of a scheduler, after temporary 
-// desactivation of the DTLB (because we use the scheduler physical address).
-// - gpid   : global processor/scheduler index
-// - value  : value to be written 
-//////////////////////////////////////////////////////////////////////////////
-inline void boot_scheduler_set_current(unsigned int gpid, unsigned int value) {
-    // get scheduler physical address
-    static_scheduler_t *psched = boot_schedulers_paddr[gpid];
-
-    // get tasks physical address
-    unsigned int * pcur = &(psched->current);
-
-    asm volatile ("li      $26,    0xB     \n"
-            "mtc2    $26,    $1      \n"    /* desactivate DTLB */
-            "sw      %1,     0(%0)   \n"    /* *pcur   <= value */
-            "li      $26,    0xF     \n"
-            "mtc2    $26,    $1      \n"    /* activate DTLB    */
-            :
-            :"r" (pcur), "r"(value)
-            :"$26");
-}
-
+            : "r" (value), "r" (lsb), "r" (msb)
+            : "$2", "$3");
+}
 
 //////////////////////////////////////////////////////////////////////////////
@@ -307,8 +199,8 @@
 // This function set a new value for the MMU PTPR register.
 //////////////////////////////////////////////////////////////////////////////
-inline void boot_set_mmu_ptpr(unsigned int val) {
+inline void boot_set_mmu_ptpr(unsigned int val) 
+{
     asm volatile ("mtc2  %0, $0"::"r" (val));
 }
-
 
 //////////////////////////////////////////////////////////////////////////////
@@ -316,31 +208,31 @@
 // This function set a new value for the MMU MODE register.
 //////////////////////////////////////////////////////////////////////////////
-inline void boot_set_mmu_mode(unsigned int val) {
+inline void boot_set_mmu_mode(unsigned int val) 
+{
     asm volatile ("mtc2  %0, $1"::"r" (val));
 }
-
 
 ////////////////////////////////////////////////////////////////////////////
 // boot_puts()
-// (it uses TTY0)
+// display a string on TTY0
 ////////////////////////////////////////////////////////////////////////////
-void boot_puts(const char * buffer) {
+void boot_puts(const char * buffer) 
+{
     unsigned int *tty_address = (unsigned int *) &seg_tty_base;
     unsigned int n;
 
-    for (n = 0; n < 100; n++) {
-        if (buffer[n] == 0) {
-            break;
-        }
+    for (n = 0; n < 100; n++) 
+    {
+        if (buffer[n] == 0)  break; 
         tty_address[TTY_WRITE] = (unsigned int) buffer[n];
     }
 }
-
 
 ////////////////////////////////////////////////////////////////////////////
 // boot_putx() 
-// (it uses TTY0)
+// display a 32 bits unsigned int as an hexadecimal string on TTY0
 ////////////////////////////////////////////////////////////////////////////
-void boot_putx(unsigned int val) {
+void boot_putx(unsigned int val) 
+{
     static const char HexaTab[] = "0123456789ABCDEF";
     char buf[11];
@@ -351,5 +243,6 @@
     buf[10] = 0;
 
-    for (c = 0; c < 8; c++) {
+    for (c = 0; c < 8; c++) 
+    {
         buf[9 - c] = HexaTab[val & 0xF];
         val = val >> 4;
@@ -358,10 +251,32 @@
 }
 
+////////////////////////////////////////////////////////////////////////////
+// boot_putl() 
+// display a 64 bits unsigned long as an hexadecimal string on TTY0
+////////////////////////////////////////////////////////////////////////////
+void boot_putl(paddr_t val) 
+{
+    static const char HexaTab[] = "0123456789ABCDEF";
+    char buf[19];
+    unsigned int c;
+
+    buf[0] = '0';
+    buf[1] = 'x';
+    buf[18] = 0;
+
+    for (c = 0; c < 16; c++) 
+    {
+        buf[17 - c] = HexaTab[(unsigned int)val & 0xF];
+        val = val >> 4;
+    }
+    boot_puts(buf);
+}
 
 ////////////////////////////////////////////////////////////////////////////
 // boot_putd() 
-// (it uses TTY0)
+// display a 32 bits unsigned int as a decimal string on TTY0
 ////////////////////////////////////////////////////////////////////////////
-void boot_putd(unsigned int val) {
+void boot_putd(unsigned int val) 
+{
     static const char DecTab[] = "0123456789";
     char buf[11];
@@ -371,10 +286,13 @@
     buf[10] = 0;
 
-    for (i = 0; i < 10; i++) {
-        if ((val != 0) || (i == 0)) {
+    for (i = 0; i < 10; i++) 
+    {
+        if ((val != 0) || (i == 0)) 
+        {
             buf[9 - i] = DecTab[val % 10];
             first = 9 - i;
         }
-        else {
+        else 
+        {
             break;
         }
@@ -384,23 +302,21 @@
 }
 
-
 /////////////////////////////////////////////////////////////////////////////
 //  mapping_info data structure access functions
 /////////////////////////////////////////////////////////////////////////////
-inline mapping_cluster_t *boot_get_cluster_base(mapping_header_t * header) {
+inline mapping_cluster_t *boot_get_cluster_base(mapping_header_t * header) 
+{
     return (mapping_cluster_t *) ((char *) header + MAPPING_HEADER_SIZE);
 }
-
-
 /////////////////////////////////////////////////////////////////////////////
-inline mapping_pseg_t *boot_get_pseg_base(mapping_header_t * header) {
+inline mapping_pseg_t *boot_get_pseg_base(mapping_header_t * header) 
+{
     return (mapping_pseg_t *) ((char *) header +
             MAPPING_HEADER_SIZE +
             MAPPING_CLUSTER_SIZE * header->clusters);
 }
-
-
 /////////////////////////////////////////////////////////////////////////////
-inline mapping_vspace_t *boot_get_vspace_base(mapping_header_t * header) {
+inline mapping_vspace_t *boot_get_vspace_base(mapping_header_t * header) 
+{
     return (mapping_vspace_t *) ((char *) header +
             MAPPING_HEADER_SIZE +
@@ -408,8 +324,7 @@
             MAPPING_PSEG_SIZE * header->psegs);
 }
-
-
 /////////////////////////////////////////////////////////////////////////////
-inline mapping_vseg_t *boot_get_vseg_base(mapping_header_t * header) {
+inline mapping_vseg_t *boot_get_vseg_base(mapping_header_t * header) 
+{
     return (mapping_vseg_t *) ((char *) header +
             MAPPING_HEADER_SIZE +
@@ -418,8 +333,7 @@
             MAPPING_VSPACE_SIZE * header->vspaces);
 }
-
-
 /////////////////////////////////////////////////////////////////////////////
-inline mapping_vobj_t *boot_get_vobj_base(mapping_header_t * header) {
+inline mapping_vobj_t *boot_get_vobj_base(mapping_header_t * header) 
+{
     return (mapping_vobj_t *) ((char *) header +
             MAPPING_HEADER_SIZE +
@@ -429,8 +343,7 @@
             MAPPING_VSEG_SIZE * header->vsegs);
 }
-
-
 /////////////////////////////////////////////////////////////////////////////
-inline mapping_task_t *boot_get_task_base(mapping_header_t * header) {
+inline mapping_task_t *boot_get_task_base(mapping_header_t * header) 
+{
     return (mapping_task_t *) ((char *) header +
             MAPPING_HEADER_SIZE +
@@ -441,8 +354,7 @@
             MAPPING_VOBJ_SIZE * header->vobjs);
 }
-
-
 /////////////////////////////////////////////////////////////////////////////
-inline mapping_proc_t *boot_get_proc_base(mapping_header_t * header) {
+inline mapping_proc_t *boot_get_proc_base(mapping_header_t * header) 
+{
     return (mapping_proc_t *) ((char *) header +
             MAPPING_HEADER_SIZE +
@@ -454,8 +366,7 @@
             MAPPING_TASK_SIZE * header->tasks);
 }
-
-
 /////////////////////////////////////////////////////////////////////////////
-inline mapping_irq_t *boot_get_irq_base(mapping_header_t * header) {
+inline mapping_irq_t *boot_get_irq_base(mapping_header_t * header) 
+{
     return (mapping_irq_t *) ((char *) header +
             MAPPING_HEADER_SIZE +
@@ -468,8 +379,7 @@
             MAPPING_PROC_SIZE * header->procs);
 }
-
-
 /////////////////////////////////////////////////////////////////////////////
-inline mapping_coproc_t *boot_get_coproc_base(mapping_header_t * header) {
+inline mapping_coproc_t *boot_get_coproc_base(mapping_header_t * header) 
+{
     return (mapping_coproc_t *) ((char *) header +
             MAPPING_HEADER_SIZE +
@@ -483,8 +393,7 @@
             MAPPING_IRQ_SIZE * header->irqs);
 }
-
-
 ///////////////////////////////////////////////////////////////////////////////////
-inline mapping_cp_port_t *boot_get_cp_port_base(mapping_header_t * header) {
+inline mapping_cp_port_t *boot_get_cp_port_base(mapping_header_t * header) 
+{
     return (mapping_cp_port_t *) ((char *) header +
             MAPPING_HEADER_SIZE +
@@ -499,8 +408,7 @@
             MAPPING_COPROC_SIZE * header->coprocs);
 }
-
-
 ///////////////////////////////////////////////////////////////////////////////////
-inline mapping_periph_t *boot_get_periph_base(mapping_header_t * header) {
+inline mapping_periph_t *boot_get_periph_base(mapping_header_t * header) 
+{
     return (mapping_periph_t *) ((char *) header +
             MAPPING_HEADER_SIZE +
@@ -517,5 +425,4 @@
 }
 
-
 //////////////////////////////////////////////////////////////////////////////
 //     boot_pseg_get() 
@@ -523,10 +430,12 @@
 // identified  by the pseg index.
 //////////////////////////////////////////////////////////////////////////////
-mapping_pseg_t *boot_pseg_get(unsigned int seg_id) {
+mapping_pseg_t *boot_pseg_get(unsigned int seg_id) 
+{
     mapping_header_t * header = (mapping_header_t *) & seg_mapping_base;
     mapping_pseg_t * pseg = boot_get_pseg_base(header);
 
     // checking argument
-    if (seg_id >= header->psegs) {
+    if (seg_id >= header->psegs) 
+    {
         boot_puts("\n[BOOT ERROR] : seg_id argument too large\n");
         boot_puts("               in function boot_pseg_get()\n");
@@ -535,26 +444,28 @@
 
     return &pseg[seg_id];
-}                // end boot_pseg_get()
-
+}  
 
 //////////////////////////////////////////////////////////////////////////////
 // boot_add_pte() 
-// This function registers a new PTE in the page table pointed
+// This function registers a new PTE in the page table defined
 // by the vspace_id argument, and updates both PT1 and PT2.
 // A new PT2 is used when required.
 // As the set of PT2s is implemented as a fixed size array (no dynamic 
 // allocation), this function checks a possible overflow of the PT2 array.
-//
-// The global parameter is a boolean indicating wether a global vseg is
-// being mapped.
 //////////////////////////////////////////////////////////////////////////////
 void boot_add_pte(unsigned int vspace_id,
-        unsigned int vpn, unsigned int flags, unsigned int ppn) {
+                  unsigned int vpn, 
+                  unsigned int flags, 
+                  unsigned int ppn,
+                  unsigned int verbose) 
+{
     unsigned int ix1;
     unsigned int ix2;
-    unsigned int ptba;      // PT2 base address
-    unsigned int pt2_id;    // PT2 index
-    unsigned int *pt_flags; // pointer on the pte_flags = &PT2[2*ix2]    
-    unsigned int *pt_ppn;   // pointer on the pte_ppn   = &PT2[2*ix2+1]  
+    paddr_t      pt1_pbase;     // PT1 physical base address
+    paddr_t      pt2_pbase;     // PT2 physical base address
+    paddr_t      pte_paddr;     // PTE physucal address
+    unsigned int pt2_id;        // PT2 index
+    unsigned int ptd;           // PTD : entry in PT1
+    unsigned int max_pt2;       // max number of PT2s for a given vspace
 
     ix1 = vpn >> 9;         // 11 bits
@@ -562,64 +473,64 @@
 
     // check that the boot_max_pt2[vspace_id] has been set
-    unsigned int max_pt2 = boot_max_pt2[vspace_id];
-
-    if (max_pt2 == 0) {
-        boot_puts("Unfound page table for vspace ");
+    max_pt2 = boot_max_pt2[vspace_id];
+
+    if (max_pt2 == 0) 
+    {
+        boot_puts("Undefined page table for vspace ");
         boot_putd(vspace_id);
         boot_puts("\n");
         boot_exit();
     }
-    // get page table physical address
-    page_table_t *pt = boot_ptabs_paddr[vspace_id];
-
-    if ((pt->pt1[ix1] & PTE_V) == 0) { // set a new PTD in PT1 
+
+    // get page table physical base address
+    pt1_pbase = boot_ptabs_paddr[vspace_id];
+
+    // get ptd in PT1
+    ptd = boot_physical_read( pt1_pbase + 4*ix1 );
+
+    if ((ptd & PTE_V) == 0)    // invalid PTD: compute PT2 base address, 
+                               // and set a new PTD in PT1 
+    {
         pt2_id = boot_next_free_pt2[vspace_id];
-        if (pt2_id == max_pt2) {
+        if (pt2_id == max_pt2) 
+        {
             boot_puts("\n[BOOT ERROR] in boot_add_pte() function\n");
             boot_puts("the length of the ptab vobj is too small\n");
             boot_exit();
         }
-        else {
-            ptba = (unsigned int) pt + PT1_SIZE + PT2_SIZE * pt2_id;
-            pt->pt1[ix1] = PTE_V | PTE_T | (ptba >> 12);
+        else 
+        {
+            pt2_pbase = pt1_pbase + PT1_SIZE + PT2_SIZE * pt2_id;
+            ptd = PTE_V | PTE_T | (unsigned int)(pt2_pbase >> 12);
+            boot_physical_write( pt1_pbase + 4*ix1 , ptd);
             boot_next_free_pt2[vspace_id] = pt2_id + 1;
         }
     }
-    else {
-        ptba = pt->pt1[ix1] << 12;
-    }
-
-    // set PTE2 
-    pt_flags = (unsigned int *) (ptba + 8 * ix2);
-    pt_ppn = (unsigned int *) (ptba + 8 * ix2 + 4);
-
-    *pt_flags = flags;
-    *pt_ppn = ppn;
-
-/*
-if ( vpn == 0x00000300)
-{
-boot_puts("vpn       = ");
-boot_putx( vpn );
-boot_puts("\n");
-boot_puts("pt_flags  = ");
-boot_putx( (unsigned int)pt_flags );
-boot_puts("\n");
-boot_puts("*pt_flags = ");
-boot_putx( *pt_flags );
-boot_puts("\n");
-boot_exit();
-}
-
-    if ((*pt_flags & PTE_V) != 0) {  // page already mapped
-        boot_puts("\n[BOOT ERROR] double mapping in vspace ");
-        boot_putd(vspace_id);
-        boot_puts(" for vpn = ");
-        boot_putx(vpn);
-        boot_puts("\n");
-        boot_exit();
-    }
-*/
-}                // end boot_add_pte()
+    else                       // valid PTD: compute PT2 base address
+    {
+        pt2_pbase = ((paddr_t)(ptd & 0x0FFFFFFF)) << 12;
+    }
+
+    // set PTE in PT2 : flags & PPN in two 32 bits words
+    pte_paddr = pt2_pbase + 8*ix2;
+    boot_physical_write( pte_paddr     , flags);
+    boot_physical_write( pte_paddr + 4 , ppn);
+
+if ( verbose )
+{
+boot_puts("     / pt1_pbase = ");
+boot_putl( pt1_pbase );
+boot_puts(" / ptd = ");
+boot_putl( ptd );
+boot_puts(" / pt2_pbase = ");
+boot_putl( pt2_pbase );
+boot_puts(" / pte_paddr = ");
+boot_putl( pte_paddr );
+boot_puts(" / ppn = ");
+boot_putx( ppn );
+boot_puts("/\n");
+}
+
+}   // end boot_add_pte()
 
 
@@ -627,8 +538,9 @@
 // This function build the page table for a given vspace. 
 // The physical base addresses for all vsegs (global and private)
-// must have been previously computed.
+// must have been previously computed and stored in the mapping.
 // It initializes the MWMR channels.
 /////////////////////////////////////////////////////////////////////
-void boot_vspace_pt_build(unsigned int vspace_id) {
+void boot_vspace_pt_build(unsigned int vspace_id) 
+{
     unsigned int vseg_id;
     unsigned int npages;
@@ -637,33 +549,25 @@
     unsigned int flags;
     unsigned int page_id;
+    unsigned int verbose = 0;   // can be used to activate trace in add_pte()
 
     mapping_header_t * header = (mapping_header_t *) & seg_mapping_base;
     mapping_vspace_t * vspace = boot_get_vspace_base(header);
-    mapping_vseg_t * vseg = boot_get_vseg_base(header);
+    mapping_vseg_t   * vseg   = boot_get_vseg_base(header);
 
     // private segments
     for (vseg_id = vspace[vspace_id].vseg_offset;
-            vseg_id < (vspace[vspace_id].vseg_offset + vspace[vspace_id].vsegs);
-            vseg_id++) {
+         vseg_id < (vspace[vspace_id].vseg_offset + vspace[vspace_id].vsegs);
+         vseg_id++) 
+    {
         vpn = vseg[vseg_id].vbase >> 12;
-        ppn = vseg[vseg_id].pbase >> 12;
+        ppn = (unsigned int)(vseg[vseg_id].pbase >> 12);
         npages = vseg[vseg_id].length >> 12;
-        if ((vseg[vseg_id].length & 0xFFF) != 0) {
-            npages++;
-        }
+        if ((vseg[vseg_id].length & 0xFFF) != 0) npages++; 
 
         flags = PTE_V;
-        if (vseg[vseg_id].mode & C_MODE_MASK) {
-            flags = flags | PTE_C;
-        }
-        if (vseg[vseg_id].mode & X_MODE_MASK) {
-            flags = flags | PTE_X;
-        }
-        if (vseg[vseg_id].mode & W_MODE_MASK) {
-            flags = flags | PTE_W;
-        }
-        if (vseg[vseg_id].mode & U_MODE_MASK) {
-            flags = flags | PTE_U;
-        }
+        if (vseg[vseg_id].mode & C_MODE_MASK)  flags = flags | PTE_C;
+        if (vseg[vseg_id].mode & X_MODE_MASK)  flags = flags | PTE_X;
+        if (vseg[vseg_id].mode & W_MODE_MASK)  flags = flags | PTE_W;
+        if (vseg[vseg_id].mode & U_MODE_MASK)  flags = flags | PTE_U;
 
 #if BOOT_DEBUG_PT
@@ -674,10 +578,11 @@
         boot_putd(npages);
         boot_puts(" / pbase = ");
-        boot_putx(vseg[vseg_id].pbase);
+        boot_putl(vseg[vseg_id].pbase);
         boot_puts("\n");
 #endif
         // loop on 4K pages
-        for (page_id = 0; page_id < npages; page_id++) {
-            boot_add_pte(vspace_id, vpn, flags, ppn);
+        for (page_id = 0; page_id < npages; page_id++) 
+        {
+            boot_add_pte(vspace_id, vpn, flags, ppn, verbose);
             vpn++;
             ppn++;
